/* FormatUtils.c generated by valac 0.56.14, the Vala compiler
 * generated from FormatUtils.vala, do not modify */

/*
* Copyright (C) 2017-2022 Lains
*
* This program is free software; you can redistribute it &&/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	NOTEJOT_FORMAT_BOLD,
	NOTEJOT_FORMAT_ITALIC,
	NOTEJOT_FORMAT_UNDERLINE,
	NOTEJOT_FORMAT_STRIKETHROUGH
} NotejotFormat;

#define NOTEJOT_TYPE_FORMAT (notejot_format_get_type ())

#define NOTEJOT_TYPE_FORMAT_BLOCK (notejot_format_block_get_type ())
typedef struct _NotejotFormatBlock NotejotFormatBlock;

struct _NotejotFormatBlock {
	gint start;
	gint end;
	NotejotFormat format;
};

VALA_EXTERN GType notejot_format_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType notejot_format_block_get_type (void) G_GNUC_CONST ;
VALA_EXTERN NotejotFormatBlock* notejot_format_block_dup (const NotejotFormatBlock* self);
VALA_EXTERN void notejot_format_block_free (NotejotFormatBlock* self);
VALA_EXTERN gchar* notejot_format_to_string (NotejotFormat fmt);
VALA_EXTERN NotejotFormat notejot_string_to_format (const gchar* wrap);

 G_GNUC_NO_INLINE static GType
notejot_format_get_type_once (void)
{
	static const GEnumValue values[] = {{NOTEJOT_FORMAT_BOLD, "NOTEJOT_FORMAT_BOLD", "bold"}, {NOTEJOT_FORMAT_ITALIC, "NOTEJOT_FORMAT_ITALIC", "italic"}, {NOTEJOT_FORMAT_UNDERLINE, "NOTEJOT_FORMAT_UNDERLINE", "underline"}, {NOTEJOT_FORMAT_STRIKETHROUGH, "NOTEJOT_FORMAT_STRIKETHROUGH", "strikethrough"}, {0, NULL, NULL}};
	GType notejot_format_type_id;
	notejot_format_type_id = g_enum_register_static ("NotejotFormat", values);
	return notejot_format_type_id;
}

GType
notejot_format_get_type (void)
{
	static gsize notejot_format_type_id__once = 0;
	if (g_once_init_enter (&notejot_format_type_id__once)) {
		GType notejot_format_type_id;
		notejot_format_type_id = notejot_format_get_type_once ();
		g_once_init_leave (&notejot_format_type_id__once, notejot_format_type_id);
	}
	return notejot_format_type_id__once;
}

NotejotFormatBlock*
notejot_format_block_dup (const NotejotFormatBlock* self)
{
	NotejotFormatBlock* dup;
#line 27 "../src/Utils/FormatUtils.vala"
	dup = g_new0 (NotejotFormatBlock, 1);
#line 27 "../src/Utils/FormatUtils.vala"
	memcpy (dup, self, sizeof (NotejotFormatBlock));
#line 27 "../src/Utils/FormatUtils.vala"
	return dup;
#line 101 "FormatUtils.c"
}

void
notejot_format_block_free (NotejotFormatBlock* self)
{
#line 27 "../src/Utils/FormatUtils.vala"
	g_free (self);
#line 109 "FormatUtils.c"
}

 G_GNUC_NO_INLINE static GType
notejot_format_block_get_type_once (void)
{
	GType notejot_format_block_type_id;
	notejot_format_block_type_id = g_boxed_type_register_static ("NotejotFormatBlock", (GBoxedCopyFunc) notejot_format_block_dup, (GBoxedFreeFunc) notejot_format_block_free);
	return notejot_format_block_type_id;
}

GType
notejot_format_block_get_type (void)
{
	static gsize notejot_format_block_type_id__once = 0;
	if (g_once_init_enter (&notejot_format_block_type_id__once)) {
		GType notejot_format_block_type_id;
		notejot_format_block_type_id = notejot_format_block_get_type_once ();
		g_once_init_leave (&notejot_format_block_type_id__once, notejot_format_block_type_id);
	}
	return notejot_format_block_type_id__once;
}

gchar*
notejot_format_to_string (NotejotFormat fmt)
{
	gchar* result;
#line 34 "../src/Utils/FormatUtils.vala"
	switch (fmt) {
#line 34 "../src/Utils/FormatUtils.vala"
		case NOTEJOT_FORMAT_BOLD:
#line 140 "FormatUtils.c"
		{
			gchar* _tmp0_;
#line 36 "../src/Utils/FormatUtils.vala"
			_tmp0_ = g_strdup ("**");
#line 36 "../src/Utils/FormatUtils.vala"
			result = _tmp0_;
#line 36 "../src/Utils/FormatUtils.vala"
			return result;
#line 149 "FormatUtils.c"
		}
#line 34 "../src/Utils/FormatUtils.vala"
		case NOTEJOT_FORMAT_ITALIC:
#line 153 "FormatUtils.c"
		{
			gchar* _tmp1_;
#line 38 "../src/Utils/FormatUtils.vala"
			_tmp1_ = g_strdup ("*");
#line 38 "../src/Utils/FormatUtils.vala"
			result = _tmp1_;
#line 38 "../src/Utils/FormatUtils.vala"
			return result;
#line 162 "FormatUtils.c"
		}
#line 34 "../src/Utils/FormatUtils.vala"
		case NOTEJOT_FORMAT_UNDERLINE:
#line 166 "FormatUtils.c"
		{
			gchar* _tmp2_;
#line 40 "../src/Utils/FormatUtils.vala"
			_tmp2_ = g_strdup ("_");
#line 40 "../src/Utils/FormatUtils.vala"
			result = _tmp2_;
#line 40 "../src/Utils/FormatUtils.vala"
			return result;
#line 175 "FormatUtils.c"
		}
#line 34 "../src/Utils/FormatUtils.vala"
		case NOTEJOT_FORMAT_STRIKETHROUGH:
#line 179 "FormatUtils.c"
		{
			gchar* _tmp3_;
#line 42 "../src/Utils/FormatUtils.vala"
			_tmp3_ = g_strdup ("~");
#line 42 "../src/Utils/FormatUtils.vala"
			result = _tmp3_;
#line 42 "../src/Utils/FormatUtils.vala"
			return result;
#line 188 "FormatUtils.c"
		}
		default:
		{
#line 44 "../src/Utils/FormatUtils.vala"
			g_assert_not_reached ();
#line 194 "FormatUtils.c"
		}
	}
}

NotejotFormat
notejot_string_to_format (const gchar* wrap)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 49 "../src/Utils/FormatUtils.vala"
	static GQuark _tmp1_label0 = 0;
#line 49 "../src/Utils/FormatUtils.vala"
	static GQuark _tmp1_label1 = 0;
#line 49 "../src/Utils/FormatUtils.vala"
	static GQuark _tmp1_label2 = 0;
#line 49 "../src/Utils/FormatUtils.vala"
	static GQuark _tmp1_label3 = 0;
#line 212 "FormatUtils.c"
	NotejotFormat result;
#line 48 "../src/Utils/FormatUtils.vala"
	g_return_val_if_fail (wrap != NULL, 0);
#line 49 "../src/Utils/FormatUtils.vala"
	_tmp0_ = wrap;
#line 49 "../src/Utils/FormatUtils.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 49 "../src/Utils/FormatUtils.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("**")))) {
#line 49 "../src/Utils/FormatUtils.vala"
		switch (0) {
#line 224 "FormatUtils.c"
			default:
			{
#line 51 "../src/Utils/FormatUtils.vala"
				result = NOTEJOT_FORMAT_BOLD;
#line 51 "../src/Utils/FormatUtils.vala"
				return result;
#line 231 "FormatUtils.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("*")))) {
#line 49 "../src/Utils/FormatUtils.vala"
		switch (0) {
#line 237 "FormatUtils.c"
			default:
			{
#line 53 "../src/Utils/FormatUtils.vala"
				result = NOTEJOT_FORMAT_ITALIC;
#line 53 "../src/Utils/FormatUtils.vala"
				return result;
#line 244 "FormatUtils.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("_")))) {
#line 49 "../src/Utils/FormatUtils.vala"
		switch (0) {
#line 250 "FormatUtils.c"
			default:
			{
#line 55 "../src/Utils/FormatUtils.vala"
				result = NOTEJOT_FORMAT_UNDERLINE;
#line 55 "../src/Utils/FormatUtils.vala"
				return result;
#line 257 "FormatUtils.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("~")))) {
#line 49 "../src/Utils/FormatUtils.vala"
		switch (0) {
#line 263 "FormatUtils.c"
			default:
			{
#line 57 "../src/Utils/FormatUtils.vala"
				result = NOTEJOT_FORMAT_STRIKETHROUGH;
#line 57 "../src/Utils/FormatUtils.vala"
				return result;
#line 270 "FormatUtils.c"
			}
		}
	} else {
#line 49 "../src/Utils/FormatUtils.vala"
		switch (0) {
#line 276 "FormatUtils.c"
			default:
			{
#line 59 "../src/Utils/FormatUtils.vala"
				g_assert_not_reached ();
#line 281 "FormatUtils.c"
			}
		}
	}
}

