/* TimeUtils.c generated by valac 0.56.14, the Vala compiler
 * generated from TimeUtils.vala, do not modify */

/*
* Copyright (C) 2017-2021 Lains
*
* This program is free software; you can redistribute it &&/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <math.h>
#include <float.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define NOTEJOT_TYPE_TIME_UTILS (notejot_time_utils_get_type ())
#define NOTEJOT_TIME_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOTEJOT_TYPE_TIME_UTILS, NotejotTimeUtils))
#define NOTEJOT_TIME_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOTEJOT_TYPE_TIME_UTILS, NotejotTimeUtilsClass))
#define NOTEJOT_IS_TIME_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOTEJOT_TYPE_TIME_UTILS))
#define NOTEJOT_IS_TIME_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOTEJOT_TYPE_TIME_UTILS))
#define NOTEJOT_TIME_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOTEJOT_TYPE_TIME_UTILS, NotejotTimeUtilsClass))

typedef struct _NotejotTimeUtils NotejotTimeUtils;
typedef struct _NotejotTimeUtilsClass NotejotTimeUtilsClass;
typedef struct _NotejotTimeUtilsPrivate NotejotTimeUtilsPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _NotejotParamSpecTimeUtils NotejotParamSpecTimeUtils;

struct _NotejotTimeUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NotejotTimeUtilsPrivate * priv;
};

struct _NotejotTimeUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (NotejotTimeUtils *self);
};

struct _NotejotParamSpecTimeUtils {
	GParamSpec parent_instance;
};

static gpointer notejot_time_utils_parent_class = NULL;

VALA_EXTERN gpointer notejot_time_utils_ref (gpointer instance);
VALA_EXTERN void notejot_time_utils_unref (gpointer instance);
VALA_EXTERN GParamSpec* notejot_param_spec_time_utils (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void notejot_value_set_time_utils (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void notejot_value_take_time_utils (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer notejot_value_get_time_utils (const GValue* value);
VALA_EXTERN GType notejot_time_utils_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NotejotTimeUtils, notejot_time_utils_unref)
VALA_EXTERN gboolean notejot_time_utils_is_same_day (GDateTime* day1,
                                         GDateTime* day2);
static gboolean notejot_time_utils_is_clock_format_12h (void);
VALA_EXTERN gchar* notejot_time_utils_get_default_date_format (gboolean with_weekday,
                                                   gboolean with_day,
                                                   gboolean with_year);
VALA_EXTERN gchar* notejot_time_utils_get_default_time_format (gboolean is_12h,
                                                   gboolean with_second);
VALA_EXTERN gchar* notejot_time_utils_get_relative_datetime (GDateTime* date_time);
VALA_EXTERN gchar* notejot_time_utils_get_relative_datetime_compact (GDateTime* date_time);
VALA_EXTERN NotejotTimeUtils* notejot_time_utils_new (void);
VALA_EXTERN NotejotTimeUtils* notejot_time_utils_construct (GType object_type);
static void notejot_time_utils_finalize (NotejotTimeUtils * obj);
static GType notejot_time_utils_get_type_once (void);

gboolean
notejot_time_utils_is_same_day (GDateTime* day1,
                                GDateTime* day2)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 21 "../src/Utils/TimeUtils.vala"
	g_return_val_if_fail (day1 != NULL, FALSE);
#line 21 "../src/Utils/TimeUtils.vala"
	g_return_val_if_fail (day2 != NULL, FALSE);
#line 22 "../src/Utils/TimeUtils.vala"
	if (g_date_time_get_day_of_year (day1) == g_date_time_get_day_of_year (day2)) {
#line 22 "../src/Utils/TimeUtils.vala"
		_tmp0_ = g_date_time_get_year (day1) == g_date_time_get_year (day2);
#line 125 "TimeUtils.c"
	} else {
#line 22 "../src/Utils/TimeUtils.vala"
		_tmp0_ = FALSE;
#line 129 "TimeUtils.c"
	}
#line 22 "../src/Utils/TimeUtils.vala"
	result = _tmp0_;
#line 22 "../src/Utils/TimeUtils.vala"
	return result;
#line 135 "TimeUtils.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 154 "TimeUtils.c"
}

static gboolean
notejot_time_utils_is_clock_format_12h (void)
{
	GSettings* h24_settings = NULL;
	GSettings* _tmp0_;
	gchar* format = NULL;
	gchar* _tmp1_;
	gboolean result;
#line 26 "../src/Utils/TimeUtils.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.interface");
#line 26 "../src/Utils/TimeUtils.vala"
	h24_settings = _tmp0_;
#line 27 "../src/Utils/TimeUtils.vala"
	_tmp1_ = g_settings_get_string (h24_settings, "clock-format");
#line 27 "../src/Utils/TimeUtils.vala"
	format = _tmp1_;
#line 28 "../src/Utils/TimeUtils.vala"
	result = string_contains (format, "12h");
#line 28 "../src/Utils/TimeUtils.vala"
	_g_free0 (format);
#line 28 "../src/Utils/TimeUtils.vala"
	_g_object_unref0 (h24_settings);
#line 28 "../src/Utils/TimeUtils.vala"
	return result;
#line 181 "TimeUtils.c"
}

gchar*
notejot_time_utils_get_default_date_format (gboolean with_weekday,
                                            gboolean with_day,
                                            gboolean with_year)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp24_;
	gchar* result;
#line 32 "../src/Utils/TimeUtils.vala"
	if (with_weekday == TRUE) {
#line 32 "../src/Utils/TimeUtils.vala"
		_tmp1_ = with_day == TRUE;
#line 197 "TimeUtils.c"
	} else {
#line 32 "../src/Utils/TimeUtils.vala"
		_tmp1_ = FALSE;
#line 201 "TimeUtils.c"
	}
#line 32 "../src/Utils/TimeUtils.vala"
	if (_tmp1_) {
#line 32 "../src/Utils/TimeUtils.vala"
		_tmp0_ = with_year == TRUE;
#line 207 "TimeUtils.c"
	} else {
#line 32 "../src/Utils/TimeUtils.vala"
		_tmp0_ = FALSE;
#line 211 "TimeUtils.c"
	}
#line 32 "../src/Utils/TimeUtils.vala"
	if (_tmp0_) {
#line 215 "TimeUtils.c"
		gchar* _tmp2_;
#line 34 "../src/Utils/TimeUtils.vala"
		_tmp2_ = g_strdup (_ ("%a, %b %e, %Y"));
#line 34 "../src/Utils/TimeUtils.vala"
		result = _tmp2_;
#line 34 "../src/Utils/TimeUtils.vala"
		return result;
#line 223 "TimeUtils.c"
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
#line 35 "../src/Utils/TimeUtils.vala"
		if (with_weekday == FALSE) {
#line 35 "../src/Utils/TimeUtils.vala"
			_tmp4_ = with_day == TRUE;
#line 231 "TimeUtils.c"
		} else {
#line 35 "../src/Utils/TimeUtils.vala"
			_tmp4_ = FALSE;
#line 235 "TimeUtils.c"
		}
#line 35 "../src/Utils/TimeUtils.vala"
		if (_tmp4_) {
#line 35 "../src/Utils/TimeUtils.vala"
			_tmp3_ = with_year == TRUE;
#line 241 "TimeUtils.c"
		} else {
#line 35 "../src/Utils/TimeUtils.vala"
			_tmp3_ = FALSE;
#line 245 "TimeUtils.c"
		}
#line 35 "../src/Utils/TimeUtils.vala"
		if (_tmp3_) {
#line 249 "TimeUtils.c"
			gchar* _tmp5_;
#line 37 "../src/Utils/TimeUtils.vala"
			_tmp5_ = g_strdup (_ ("%b %e %Y"));
#line 37 "../src/Utils/TimeUtils.vala"
			result = _tmp5_;
#line 37 "../src/Utils/TimeUtils.vala"
			return result;
#line 257 "TimeUtils.c"
		} else {
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
#line 38 "../src/Utils/TimeUtils.vala"
			if (with_weekday == FALSE) {
#line 38 "../src/Utils/TimeUtils.vala"
				_tmp7_ = with_day == FALSE;
#line 265 "TimeUtils.c"
			} else {
#line 38 "../src/Utils/TimeUtils.vala"
				_tmp7_ = FALSE;
#line 269 "TimeUtils.c"
			}
#line 38 "../src/Utils/TimeUtils.vala"
			if (_tmp7_) {
#line 38 "../src/Utils/TimeUtils.vala"
				_tmp6_ = with_year == TRUE;
#line 275 "TimeUtils.c"
			} else {
#line 38 "../src/Utils/TimeUtils.vala"
				_tmp6_ = FALSE;
#line 279 "TimeUtils.c"
			}
#line 38 "../src/Utils/TimeUtils.vala"
			if (_tmp6_) {
#line 283 "TimeUtils.c"
				gchar* _tmp8_;
#line 40 "../src/Utils/TimeUtils.vala"
				_tmp8_ = g_strdup (_ ("%Y"));
#line 40 "../src/Utils/TimeUtils.vala"
				result = _tmp8_;
#line 40 "../src/Utils/TimeUtils.vala"
				return result;
#line 291 "TimeUtils.c"
			} else {
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
#line 41 "../src/Utils/TimeUtils.vala"
				if (with_weekday == FALSE) {
#line 41 "../src/Utils/TimeUtils.vala"
					_tmp10_ = with_day == TRUE;
#line 299 "TimeUtils.c"
				} else {
#line 41 "../src/Utils/TimeUtils.vala"
					_tmp10_ = FALSE;
#line 303 "TimeUtils.c"
				}
#line 41 "../src/Utils/TimeUtils.vala"
				if (_tmp10_) {
#line 41 "../src/Utils/TimeUtils.vala"
					_tmp9_ = with_year == FALSE;
#line 309 "TimeUtils.c"
				} else {
#line 41 "../src/Utils/TimeUtils.vala"
					_tmp9_ = FALSE;
#line 313 "TimeUtils.c"
				}
#line 41 "../src/Utils/TimeUtils.vala"
				if (_tmp9_) {
#line 317 "TimeUtils.c"
					gchar* _tmp11_;
#line 43 "../src/Utils/TimeUtils.vala"
					_tmp11_ = g_strdup (_ ("%b %e"));
#line 43 "../src/Utils/TimeUtils.vala"
					result = _tmp11_;
#line 43 "../src/Utils/TimeUtils.vala"
					return result;
#line 325 "TimeUtils.c"
				} else {
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
#line 44 "../src/Utils/TimeUtils.vala"
					if (with_weekday == TRUE) {
#line 44 "../src/Utils/TimeUtils.vala"
						_tmp13_ = with_day == FALSE;
#line 333 "TimeUtils.c"
					} else {
#line 44 "../src/Utils/TimeUtils.vala"
						_tmp13_ = FALSE;
#line 337 "TimeUtils.c"
					}
#line 44 "../src/Utils/TimeUtils.vala"
					if (_tmp13_) {
#line 44 "../src/Utils/TimeUtils.vala"
						_tmp12_ = with_year == TRUE;
#line 343 "TimeUtils.c"
					} else {
#line 44 "../src/Utils/TimeUtils.vala"
						_tmp12_ = FALSE;
#line 347 "TimeUtils.c"
					}
#line 44 "../src/Utils/TimeUtils.vala"
					if (_tmp12_) {
#line 351 "TimeUtils.c"
						gchar* _tmp14_;
#line 46 "../src/Utils/TimeUtils.vala"
						_tmp14_ = g_strdup (_ ("%a %Y"));
#line 46 "../src/Utils/TimeUtils.vala"
						result = _tmp14_;
#line 46 "../src/Utils/TimeUtils.vala"
						return result;
#line 359 "TimeUtils.c"
					} else {
						gboolean _tmp15_ = FALSE;
						gboolean _tmp16_ = FALSE;
#line 47 "../src/Utils/TimeUtils.vala"
						if (with_weekday == TRUE) {
#line 47 "../src/Utils/TimeUtils.vala"
							_tmp16_ = with_day == FALSE;
#line 367 "TimeUtils.c"
						} else {
#line 47 "../src/Utils/TimeUtils.vala"
							_tmp16_ = FALSE;
#line 371 "TimeUtils.c"
						}
#line 47 "../src/Utils/TimeUtils.vala"
						if (_tmp16_) {
#line 47 "../src/Utils/TimeUtils.vala"
							_tmp15_ = with_year == FALSE;
#line 377 "TimeUtils.c"
						} else {
#line 47 "../src/Utils/TimeUtils.vala"
							_tmp15_ = FALSE;
#line 381 "TimeUtils.c"
						}
#line 47 "../src/Utils/TimeUtils.vala"
						if (_tmp15_) {
#line 385 "TimeUtils.c"
							gchar* _tmp17_;
#line 49 "../src/Utils/TimeUtils.vala"
							_tmp17_ = g_strdup (_ ("%a"));
#line 49 "../src/Utils/TimeUtils.vala"
							result = _tmp17_;
#line 49 "../src/Utils/TimeUtils.vala"
							return result;
#line 393 "TimeUtils.c"
						} else {
							gboolean _tmp18_ = FALSE;
							gboolean _tmp19_ = FALSE;
#line 50 "../src/Utils/TimeUtils.vala"
							if (with_weekday == TRUE) {
#line 50 "../src/Utils/TimeUtils.vala"
								_tmp19_ = with_day == TRUE;
#line 401 "TimeUtils.c"
							} else {
#line 50 "../src/Utils/TimeUtils.vala"
								_tmp19_ = FALSE;
#line 405 "TimeUtils.c"
							}
#line 50 "../src/Utils/TimeUtils.vala"
							if (_tmp19_) {
#line 50 "../src/Utils/TimeUtils.vala"
								_tmp18_ = with_year == FALSE;
#line 411 "TimeUtils.c"
							} else {
#line 50 "../src/Utils/TimeUtils.vala"
								_tmp18_ = FALSE;
#line 415 "TimeUtils.c"
							}
#line 50 "../src/Utils/TimeUtils.vala"
							if (_tmp18_) {
#line 419 "TimeUtils.c"
								gchar* _tmp20_;
#line 52 "../src/Utils/TimeUtils.vala"
								_tmp20_ = g_strdup (_ ("%a, %b %e"));
#line 52 "../src/Utils/TimeUtils.vala"
								result = _tmp20_;
#line 52 "../src/Utils/TimeUtils.vala"
								return result;
#line 427 "TimeUtils.c"
							} else {
								gboolean _tmp21_ = FALSE;
								gboolean _tmp22_ = FALSE;
#line 53 "../src/Utils/TimeUtils.vala"
								if (with_weekday == FALSE) {
#line 53 "../src/Utils/TimeUtils.vala"
									_tmp22_ = with_day == FALSE;
#line 435 "TimeUtils.c"
								} else {
#line 53 "../src/Utils/TimeUtils.vala"
									_tmp22_ = FALSE;
#line 439 "TimeUtils.c"
								}
#line 53 "../src/Utils/TimeUtils.vala"
								if (_tmp22_) {
#line 53 "../src/Utils/TimeUtils.vala"
									_tmp21_ = with_year == FALSE;
#line 445 "TimeUtils.c"
								} else {
#line 53 "../src/Utils/TimeUtils.vala"
									_tmp21_ = FALSE;
#line 449 "TimeUtils.c"
								}
#line 53 "../src/Utils/TimeUtils.vala"
								if (_tmp21_) {
#line 453 "TimeUtils.c"
									gchar* _tmp23_;
#line 55 "../src/Utils/TimeUtils.vala"
									_tmp23_ = g_strdup (_ ("%b"));
#line 55 "../src/Utils/TimeUtils.vala"
									result = _tmp23_;
#line 55 "../src/Utils/TimeUtils.vala"
									return result;
#line 461 "TimeUtils.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 58 "../src/Utils/TimeUtils.vala"
	_tmp24_ = g_strdup ("");
#line 58 "../src/Utils/TimeUtils.vala"
	result = _tmp24_;
#line 58 "../src/Utils/TimeUtils.vala"
	return result;
#line 476 "TimeUtils.c"
}

gchar*
notejot_time_utils_get_default_time_format (gboolean is_12h,
                                            gboolean with_second)
{
	gchar* result;
#line 62 "../src/Utils/TimeUtils.vala"
	if (is_12h == TRUE) {
#line 63 "../src/Utils/TimeUtils.vala"
		if (with_second == TRUE) {
#line 488 "TimeUtils.c"
			gchar* _tmp0_;
#line 65 "../src/Utils/TimeUtils.vala"
			_tmp0_ = g_strdup (_ ("%-l:%M:%S %p"));
#line 65 "../src/Utils/TimeUtils.vala"
			result = _tmp0_;
#line 65 "../src/Utils/TimeUtils.vala"
			return result;
#line 496 "TimeUtils.c"
		} else {
			gchar* _tmp1_;
#line 68 "../src/Utils/TimeUtils.vala"
			_tmp1_ = g_strdup (_ ("%-l:%M %p"));
#line 68 "../src/Utils/TimeUtils.vala"
			result = _tmp1_;
#line 68 "../src/Utils/TimeUtils.vala"
			return result;
#line 505 "TimeUtils.c"
		}
	} else {
#line 71 "../src/Utils/TimeUtils.vala"
		if (with_second == TRUE) {
#line 510 "TimeUtils.c"
			gchar* _tmp2_;
#line 73 "../src/Utils/TimeUtils.vala"
			_tmp2_ = g_strdup (_ ("%H:%M:%S"));
#line 73 "../src/Utils/TimeUtils.vala"
			result = _tmp2_;
#line 73 "../src/Utils/TimeUtils.vala"
			return result;
#line 518 "TimeUtils.c"
		} else {
			gchar* _tmp3_;
#line 76 "../src/Utils/TimeUtils.vala"
			_tmp3_ = g_strdup (_ ("%H:%M"));
#line 76 "../src/Utils/TimeUtils.vala"
			result = _tmp3_;
#line 76 "../src/Utils/TimeUtils.vala"
			return result;
#line 527 "TimeUtils.c"
		}
	}
}

gchar*
notejot_time_utils_get_relative_datetime (GDateTime* date_time)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GTimeSpan diff = 0LL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* result;
#line 91 "../src/Utils/TimeUtils.vala"
	g_return_val_if_fail (date_time != NULL, NULL);
#line 92 "../src/Utils/TimeUtils.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 92 "../src/Utils/TimeUtils.vala"
	now = _tmp0_;
#line 93 "../src/Utils/TimeUtils.vala"
	_tmp1_ = now;
#line 93 "../src/Utils/TimeUtils.vala"
	diff = g_date_time_difference (_tmp1_, date_time);
#line 95 "../src/Utils/TimeUtils.vala"
	_tmp2_ = now;
#line 95 "../src/Utils/TimeUtils.vala"
	if (notejot_time_utils_is_same_day (date_time, _tmp2_)) {
#line 555 "TimeUtils.c"
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 96 "../src/Utils/TimeUtils.vala"
		if (diff > ((GTimeSpan) 0)) {
#line 97 "../src/Utils/TimeUtils.vala"
			if (diff < G_TIME_SPAN_MINUTE) {
#line 564 "TimeUtils.c"
				gchar* _tmp3_;
#line 98 "../src/Utils/TimeUtils.vala"
				_tmp3_ = g_strdup (_ ("Now"));
#line 98 "../src/Utils/TimeUtils.vala"
				result = _tmp3_;
#line 98 "../src/Utils/TimeUtils.vala"
				_g_date_time_unref0 (now);
#line 98 "../src/Utils/TimeUtils.vala"
				return result;
#line 574 "TimeUtils.c"
			} else {
#line 99 "../src/Utils/TimeUtils.vala"
				if (diff < G_TIME_SPAN_HOUR) {
#line 578 "TimeUtils.c"
					GTimeSpan minutes = 0LL;
					gchar* _tmp4_;
#line 100 "../src/Utils/TimeUtils.vala"
					minutes = diff / G_TIME_SPAN_MINUTE;
#line 101 "../src/Utils/TimeUtils.vala"
					_tmp4_ = g_strdup_printf (ngettext ("%d minute ago", "%d minutes ago", (gulong) minutes), (gint) minutes);
#line 101 "../src/Utils/TimeUtils.vala"
					result = _tmp4_;
#line 101 "../src/Utils/TimeUtils.vala"
					_g_date_time_unref0 (now);
#line 101 "../src/Utils/TimeUtils.vala"
					return result;
#line 591 "TimeUtils.c"
				} else {
#line 102 "../src/Utils/TimeUtils.vala"
					if (diff < (12 * G_TIME_SPAN_HOUR)) {
#line 595 "TimeUtils.c"
						gint rounded = 0;
						gchar* _tmp5_;
#line 103 "../src/Utils/TimeUtils.vala"
						rounded = (gint) round (((gdouble) diff) / G_TIME_SPAN_HOUR);
#line 104 "../src/Utils/TimeUtils.vala"
						_tmp5_ = g_strdup_printf (ngettext ("%d hour ago", "%d hours ago", (gulong) rounded), rounded);
#line 104 "../src/Utils/TimeUtils.vala"
						result = _tmp5_;
#line 104 "../src/Utils/TimeUtils.vala"
						_g_date_time_unref0 (now);
#line 104 "../src/Utils/TimeUtils.vala"
						return result;
#line 608 "TimeUtils.c"
					}
				}
			}
		} else {
#line 107 "../src/Utils/TimeUtils.vala"
			diff = -1 * diff;
#line 108 "../src/Utils/TimeUtils.vala"
			if (diff < G_TIME_SPAN_HOUR) {
#line 617 "TimeUtils.c"
				GTimeSpan minutes = 0LL;
				gchar* _tmp6_;
#line 109 "../src/Utils/TimeUtils.vala"
				minutes = diff / G_TIME_SPAN_MINUTE;
#line 110 "../src/Utils/TimeUtils.vala"
				_tmp6_ = g_strdup_printf (ngettext ("in %d minute", "in %d minutes", (gulong) minutes), (gint) minutes);
#line 110 "../src/Utils/TimeUtils.vala"
				result = _tmp6_;
#line 110 "../src/Utils/TimeUtils.vala"
				_g_date_time_unref0 (now);
#line 110 "../src/Utils/TimeUtils.vala"
				return result;
#line 630 "TimeUtils.c"
			} else {
#line 111 "../src/Utils/TimeUtils.vala"
				if (diff < (12 * G_TIME_SPAN_HOUR)) {
#line 634 "TimeUtils.c"
					gint rounded = 0;
					gchar* _tmp7_;
#line 112 "../src/Utils/TimeUtils.vala"
					rounded = (gint) round (((gdouble) diff) / G_TIME_SPAN_HOUR);
#line 113 "../src/Utils/TimeUtils.vala"
					_tmp7_ = g_strdup_printf (ngettext ("in %d hour", "in %d hours", (gulong) rounded), rounded);
#line 113 "../src/Utils/TimeUtils.vala"
					result = _tmp7_;
#line 113 "../src/Utils/TimeUtils.vala"
					_g_date_time_unref0 (now);
#line 113 "../src/Utils/TimeUtils.vala"
					return result;
#line 647 "TimeUtils.c"
				}
			}
		}
#line 117 "../src/Utils/TimeUtils.vala"
		_tmp8_ = notejot_time_utils_get_default_time_format (notejot_time_utils_is_clock_format_12h (), FALSE);
#line 117 "../src/Utils/TimeUtils.vala"
		_tmp9_ = _tmp8_;
#line 117 "../src/Utils/TimeUtils.vala"
		_tmp10_ = g_date_time_format (date_time, _tmp9_);
#line 117 "../src/Utils/TimeUtils.vala"
		_tmp11_ = _tmp10_;
#line 117 "../src/Utils/TimeUtils.vala"
		_g_free0 (_tmp9_);
#line 117 "../src/Utils/TimeUtils.vala"
		result = _tmp11_;
#line 117 "../src/Utils/TimeUtils.vala"
		_g_date_time_unref0 (now);
#line 117 "../src/Utils/TimeUtils.vala"
		return result;
#line 667 "TimeUtils.c"
	} else {
		GDateTime* _tmp12_;
		GDateTime* _tmp13_;
		GDateTime* _tmp14_;
		gboolean _tmp15_;
#line 118 "../src/Utils/TimeUtils.vala"
		_tmp12_ = g_date_time_add_days (date_time, 1);
#line 118 "../src/Utils/TimeUtils.vala"
		_tmp13_ = _tmp12_;
#line 118 "../src/Utils/TimeUtils.vala"
		_tmp14_ = now;
#line 118 "../src/Utils/TimeUtils.vala"
		_tmp15_ = notejot_time_utils_is_same_day (_tmp13_, _tmp14_);
#line 118 "../src/Utils/TimeUtils.vala"
		_g_date_time_unref0 (_tmp13_);
#line 118 "../src/Utils/TimeUtils.vala"
		if (_tmp15_) {
#line 685 "TimeUtils.c"
			gchar* _tmp16_;
#line 119 "../src/Utils/TimeUtils.vala"
			_tmp16_ = g_strdup (_ ("Yesterday"));
#line 119 "../src/Utils/TimeUtils.vala"
			result = _tmp16_;
#line 119 "../src/Utils/TimeUtils.vala"
			_g_date_time_unref0 (now);
#line 119 "../src/Utils/TimeUtils.vala"
			return result;
#line 695 "TimeUtils.c"
		} else {
			GDateTime* _tmp17_;
			GDateTime* _tmp18_;
			GDateTime* _tmp19_;
			gboolean _tmp20_;
#line 120 "../src/Utils/TimeUtils.vala"
			_tmp17_ = g_date_time_add_days (date_time, -1);
#line 120 "../src/Utils/TimeUtils.vala"
			_tmp18_ = _tmp17_;
#line 120 "../src/Utils/TimeUtils.vala"
			_tmp19_ = now;
#line 120 "../src/Utils/TimeUtils.vala"
			_tmp20_ = notejot_time_utils_is_same_day (_tmp18_, _tmp19_);
#line 120 "../src/Utils/TimeUtils.vala"
			_g_date_time_unref0 (_tmp18_);
#line 120 "../src/Utils/TimeUtils.vala"
			if (_tmp20_) {
#line 713 "TimeUtils.c"
				gchar* _tmp21_;
#line 121 "../src/Utils/TimeUtils.vala"
				_tmp21_ = g_strdup (_ ("Tomorrow"));
#line 121 "../src/Utils/TimeUtils.vala"
				result = _tmp21_;
#line 121 "../src/Utils/TimeUtils.vala"
				_g_date_time_unref0 (now);
#line 121 "../src/Utils/TimeUtils.vala"
				return result;
#line 723 "TimeUtils.c"
			} else {
				gboolean _tmp22_ = FALSE;
#line 122 "../src/Utils/TimeUtils.vala"
				if (diff < (6 * G_TIME_SPAN_DAY)) {
#line 122 "../src/Utils/TimeUtils.vala"
					_tmp22_ = diff > (-6 * G_TIME_SPAN_DAY);
#line 730 "TimeUtils.c"
				} else {
#line 122 "../src/Utils/TimeUtils.vala"
					_tmp22_ = FALSE;
#line 734 "TimeUtils.c"
				}
#line 122 "../src/Utils/TimeUtils.vala"
				if (_tmp22_) {
#line 738 "TimeUtils.c"
					gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
#line 123 "../src/Utils/TimeUtils.vala"
					_tmp23_ = notejot_time_utils_get_default_date_format (TRUE, FALSE, FALSE);
#line 123 "../src/Utils/TimeUtils.vala"
					_tmp24_ = _tmp23_;
#line 123 "../src/Utils/TimeUtils.vala"
					_tmp25_ = g_date_time_format (date_time, _tmp24_);
#line 123 "../src/Utils/TimeUtils.vala"
					_tmp26_ = _tmp25_;
#line 123 "../src/Utils/TimeUtils.vala"
					_g_free0 (_tmp24_);
#line 123 "../src/Utils/TimeUtils.vala"
					result = _tmp26_;
#line 123 "../src/Utils/TimeUtils.vala"
					_g_date_time_unref0 (now);
#line 123 "../src/Utils/TimeUtils.vala"
					return result;
#line 759 "TimeUtils.c"
				} else {
					GDateTime* _tmp27_;
#line 124 "../src/Utils/TimeUtils.vala"
					_tmp27_ = now;
#line 124 "../src/Utils/TimeUtils.vala"
					if (g_date_time_get_year (date_time) == g_date_time_get_year (_tmp27_)) {
#line 766 "TimeUtils.c"
						gchar* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
#line 125 "../src/Utils/TimeUtils.vala"
						_tmp28_ = notejot_time_utils_get_default_date_format (FALSE, TRUE, FALSE);
#line 125 "../src/Utils/TimeUtils.vala"
						_tmp29_ = _tmp28_;
#line 125 "../src/Utils/TimeUtils.vala"
						_tmp30_ = g_date_time_format (date_time, _tmp29_);
#line 125 "../src/Utils/TimeUtils.vala"
						_tmp31_ = _tmp30_;
#line 125 "../src/Utils/TimeUtils.vala"
						_g_free0 (_tmp29_);
#line 125 "../src/Utils/TimeUtils.vala"
						result = _tmp31_;
#line 125 "../src/Utils/TimeUtils.vala"
						_g_date_time_unref0 (now);
#line 125 "../src/Utils/TimeUtils.vala"
						return result;
#line 787 "TimeUtils.c"
					} else {
						gchar* _tmp32_;
#line 127 "../src/Utils/TimeUtils.vala"
						_tmp32_ = g_date_time_format (date_time, "%x");
#line 127 "../src/Utils/TimeUtils.vala"
						result = _tmp32_;
#line 127 "../src/Utils/TimeUtils.vala"
						_g_date_time_unref0 (now);
#line 127 "../src/Utils/TimeUtils.vala"
						return result;
#line 798 "TimeUtils.c"
					}
				}
			}
		}
	}
}

gchar*
notejot_time_utils_get_relative_datetime_compact (GDateTime* date_time)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GTimeSpan diff = 0LL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gboolean _tmp8_ = FALSE;
	gchar* result;
#line 137 "../src/Utils/TimeUtils.vala"
	g_return_val_if_fail (date_time != NULL, NULL);
#line 138 "../src/Utils/TimeUtils.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 138 "../src/Utils/TimeUtils.vala"
	now = _tmp0_;
#line 139 "../src/Utils/TimeUtils.vala"
	_tmp1_ = now;
#line 139 "../src/Utils/TimeUtils.vala"
	diff = g_date_time_difference (_tmp1_, date_time);
#line 141 "../src/Utils/TimeUtils.vala"
	_tmp2_ = now;
#line 141 "../src/Utils/TimeUtils.vala"
	if (notejot_time_utils_is_same_day (date_time, _tmp2_)) {
#line 830 "TimeUtils.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 142 "../src/Utils/TimeUtils.vala"
		if (diff > ((GTimeSpan) 0)) {
#line 143 "../src/Utils/TimeUtils.vala"
			if (diff < (12 * G_TIME_SPAN_HOUR)) {
#line 839 "TimeUtils.c"
				gchar* _tmp3_;
#line 144 "../src/Utils/TimeUtils.vala"
				_tmp3_ = g_date_time_format (date_time, "%H:%M");
#line 144 "../src/Utils/TimeUtils.vala"
				result = _tmp3_;
#line 144 "../src/Utils/TimeUtils.vala"
				_g_date_time_unref0 (now);
#line 144 "../src/Utils/TimeUtils.vala"
				return result;
#line 849 "TimeUtils.c"
			}
		}
#line 148 "../src/Utils/TimeUtils.vala"
		_tmp4_ = notejot_time_utils_get_default_time_format (notejot_time_utils_is_clock_format_12h (), FALSE);
#line 148 "../src/Utils/TimeUtils.vala"
		_tmp5_ = _tmp4_;
#line 148 "../src/Utils/TimeUtils.vala"
		_tmp6_ = g_date_time_format (date_time, _tmp5_);
#line 148 "../src/Utils/TimeUtils.vala"
		_tmp7_ = _tmp6_;
#line 148 "../src/Utils/TimeUtils.vala"
		_g_free0 (_tmp5_);
#line 148 "../src/Utils/TimeUtils.vala"
		result = _tmp7_;
#line 148 "../src/Utils/TimeUtils.vala"
		_g_date_time_unref0 (now);
#line 148 "../src/Utils/TimeUtils.vala"
		return result;
#line 868 "TimeUtils.c"
	}
#line 149 "../src/Utils/TimeUtils.vala"
	if (diff < (6 * G_TIME_SPAN_DAY)) {
#line 149 "../src/Utils/TimeUtils.vala"
		_tmp8_ = diff > (-6 * G_TIME_SPAN_DAY);
#line 874 "TimeUtils.c"
	} else {
#line 149 "../src/Utils/TimeUtils.vala"
		_tmp8_ = FALSE;
#line 878 "TimeUtils.c"
	}
#line 149 "../src/Utils/TimeUtils.vala"
	if (_tmp8_) {
#line 882 "TimeUtils.c"
		gchar* _tmp9_;
#line 150 "../src/Utils/TimeUtils.vala"
		_tmp9_ = g_date_time_format (date_time, "%A");
#line 150 "../src/Utils/TimeUtils.vala"
		result = _tmp9_;
#line 150 "../src/Utils/TimeUtils.vala"
		_g_date_time_unref0 (now);
#line 150 "../src/Utils/TimeUtils.vala"
		return result;
#line 892 "TimeUtils.c"
	} else {
		gchar* _tmp10_;
#line 152 "../src/Utils/TimeUtils.vala"
		_tmp10_ = g_date_time_format (date_time, "%d/%m");
#line 152 "../src/Utils/TimeUtils.vala"
		result = _tmp10_;
#line 152 "../src/Utils/TimeUtils.vala"
		_g_date_time_unref0 (now);
#line 152 "../src/Utils/TimeUtils.vala"
		return result;
#line 903 "TimeUtils.c"
	}
}

NotejotTimeUtils*
notejot_time_utils_construct (GType object_type)
{
	NotejotTimeUtils* self = NULL;
#line 20 "../src/Utils/TimeUtils.vala"
	self = (NotejotTimeUtils*) g_type_create_instance (object_type);
#line 20 "../src/Utils/TimeUtils.vala"
	return self;
#line 915 "TimeUtils.c"
}

NotejotTimeUtils*
notejot_time_utils_new (void)
{
#line 20 "../src/Utils/TimeUtils.vala"
	return notejot_time_utils_construct (NOTEJOT_TYPE_TIME_UTILS);
#line 923 "TimeUtils.c"
}

static void
notejot_value_time_utils_init (GValue* value)
{
#line 20 "../src/Utils/TimeUtils.vala"
	value->data[0].v_pointer = NULL;
#line 931 "TimeUtils.c"
}

static void
notejot_value_time_utils_free_value (GValue* value)
{
#line 20 "../src/Utils/TimeUtils.vala"
	if (value->data[0].v_pointer) {
#line 20 "../src/Utils/TimeUtils.vala"
		notejot_time_utils_unref (value->data[0].v_pointer);
#line 941 "TimeUtils.c"
	}
}

static void
notejot_value_time_utils_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
#line 20 "../src/Utils/TimeUtils.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "../src/Utils/TimeUtils.vala"
		dest_value->data[0].v_pointer = notejot_time_utils_ref (src_value->data[0].v_pointer);
#line 953 "TimeUtils.c"
	} else {
#line 20 "../src/Utils/TimeUtils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 957 "TimeUtils.c"
	}
}

static gpointer
notejot_value_time_utils_peek_pointer (const GValue* value)
{
#line 20 "../src/Utils/TimeUtils.vala"
	return value->data[0].v_pointer;
#line 966 "TimeUtils.c"
}

static gchar*
notejot_value_time_utils_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
#line 20 "../src/Utils/TimeUtils.vala"
	if (collect_values[0].v_pointer) {
#line 977 "TimeUtils.c"
		NotejotTimeUtils * object;
		object = collect_values[0].v_pointer;
#line 20 "../src/Utils/TimeUtils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "../src/Utils/TimeUtils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 984 "TimeUtils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "../src/Utils/TimeUtils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 988 "TimeUtils.c"
		}
#line 20 "../src/Utils/TimeUtils.vala"
		value->data[0].v_pointer = notejot_time_utils_ref (object);
#line 992 "TimeUtils.c"
	} else {
#line 20 "../src/Utils/TimeUtils.vala"
		value->data[0].v_pointer = NULL;
#line 996 "TimeUtils.c"
	}
#line 20 "../src/Utils/TimeUtils.vala"
	return NULL;
#line 1000 "TimeUtils.c"
}

static gchar*
notejot_value_time_utils_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	NotejotTimeUtils ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "../src/Utils/TimeUtils.vala"
	if (!object_p) {
#line 20 "../src/Utils/TimeUtils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1015 "TimeUtils.c"
	}
#line 20 "../src/Utils/TimeUtils.vala"
	if (!value->data[0].v_pointer) {
#line 20 "../src/Utils/TimeUtils.vala"
		*object_p = NULL;
#line 1021 "TimeUtils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "../src/Utils/TimeUtils.vala"
		*object_p = value->data[0].v_pointer;
#line 1025 "TimeUtils.c"
	} else {
#line 20 "../src/Utils/TimeUtils.vala"
		*object_p = notejot_time_utils_ref (value->data[0].v_pointer);
#line 1029 "TimeUtils.c"
	}
#line 20 "../src/Utils/TimeUtils.vala"
	return NULL;
#line 1033 "TimeUtils.c"
}

GParamSpec*
notejot_param_spec_time_utils (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	NotejotParamSpecTimeUtils* spec;
#line 20 "../src/Utils/TimeUtils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, NOTEJOT_TYPE_TIME_UTILS), NULL);
#line 20 "../src/Utils/TimeUtils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "../src/Utils/TimeUtils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "../src/Utils/TimeUtils.vala"
	return G_PARAM_SPEC (spec);
#line 1052 "TimeUtils.c"
}

gpointer
notejot_value_get_time_utils (const GValue* value)
{
#line 20 "../src/Utils/TimeUtils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NOTEJOT_TYPE_TIME_UTILS), NULL);
#line 20 "../src/Utils/TimeUtils.vala"
	return value->data[0].v_pointer;
#line 1062 "TimeUtils.c"
}

void
notejot_value_set_time_utils (GValue* value,
                              gpointer v_object)
{
	NotejotTimeUtils * old;
#line 20 "../src/Utils/TimeUtils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NOTEJOT_TYPE_TIME_UTILS));
#line 20 "../src/Utils/TimeUtils.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/Utils/TimeUtils.vala"
	if (v_object) {
#line 20 "../src/Utils/TimeUtils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NOTEJOT_TYPE_TIME_UTILS));
#line 20 "../src/Utils/TimeUtils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/Utils/TimeUtils.vala"
		value->data[0].v_pointer = v_object;
#line 20 "../src/Utils/TimeUtils.vala"
		notejot_time_utils_ref (value->data[0].v_pointer);
#line 1084 "TimeUtils.c"
	} else {
#line 20 "../src/Utils/TimeUtils.vala"
		value->data[0].v_pointer = NULL;
#line 1088 "TimeUtils.c"
	}
#line 20 "../src/Utils/TimeUtils.vala"
	if (old) {
#line 20 "../src/Utils/TimeUtils.vala"
		notejot_time_utils_unref (old);
#line 1094 "TimeUtils.c"
	}
}

void
notejot_value_take_time_utils (GValue* value,
                               gpointer v_object)
{
	NotejotTimeUtils * old;
#line 20 "../src/Utils/TimeUtils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NOTEJOT_TYPE_TIME_UTILS));
#line 20 "../src/Utils/TimeUtils.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/Utils/TimeUtils.vala"
	if (v_object) {
#line 20 "../src/Utils/TimeUtils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NOTEJOT_TYPE_TIME_UTILS));
#line 20 "../src/Utils/TimeUtils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/Utils/TimeUtils.vala"
		value->data[0].v_pointer = v_object;
#line 1115 "TimeUtils.c"
	} else {
#line 20 "../src/Utils/TimeUtils.vala"
		value->data[0].v_pointer = NULL;
#line 1119 "TimeUtils.c"
	}
#line 20 "../src/Utils/TimeUtils.vala"
	if (old) {
#line 20 "../src/Utils/TimeUtils.vala"
		notejot_time_utils_unref (old);
#line 1125 "TimeUtils.c"
	}
}

static void
notejot_time_utils_class_init (NotejotTimeUtilsClass * klass,
                               gpointer klass_data)
{
#line 20 "../src/Utils/TimeUtils.vala"
	notejot_time_utils_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Utils/TimeUtils.vala"
	((NotejotTimeUtilsClass *) klass)->finalize = notejot_time_utils_finalize;
#line 1137 "TimeUtils.c"
}

static void
notejot_time_utils_instance_init (NotejotTimeUtils * self,
                                  gpointer klass)
{
#line 20 "../src/Utils/TimeUtils.vala"
	self->ref_count = 1;
#line 1146 "TimeUtils.c"
}

static void
notejot_time_utils_finalize (NotejotTimeUtils * obj)
{
	NotejotTimeUtils * self;
#line 20 "../src/Utils/TimeUtils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOTEJOT_TYPE_TIME_UTILS, NotejotTimeUtils);
#line 20 "../src/Utils/TimeUtils.vala"
	g_signal_handlers_destroy (self);
#line 1157 "TimeUtils.c"
}

 G_GNUC_NO_INLINE static GType
notejot_time_utils_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { notejot_value_time_utils_init, notejot_value_time_utils_free_value, notejot_value_time_utils_copy_value, notejot_value_time_utils_peek_pointer, "p", notejot_value_time_utils_collect_value, "p", notejot_value_time_utils_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (NotejotTimeUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notejot_time_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotejotTimeUtils), 0, (GInstanceInitFunc) notejot_time_utils_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType notejot_time_utils_type_id;
	notejot_time_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NotejotTimeUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return notejot_time_utils_type_id;
}

GType
notejot_time_utils_get_type (void)
{
	static gsize notejot_time_utils_type_id__once = 0;
	if (g_once_init_enter (&notejot_time_utils_type_id__once)) {
		GType notejot_time_utils_type_id;
		notejot_time_utils_type_id = notejot_time_utils_get_type_once ();
		g_once_init_leave (&notejot_time_utils_type_id__once, notejot_time_utils_type_id);
	}
	return notejot_time_utils_type_id__once;
}

gpointer
notejot_time_utils_ref (gpointer instance)
{
	NotejotTimeUtils * self;
	self = instance;
#line 20 "../src/Utils/TimeUtils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "../src/Utils/TimeUtils.vala"
	return instance;
#line 1192 "TimeUtils.c"
}

void
notejot_time_utils_unref (gpointer instance)
{
	NotejotTimeUtils * self;
	self = instance;
#line 20 "../src/Utils/TimeUtils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "../src/Utils/TimeUtils.vala"
		NOTEJOT_TIME_UTILS_GET_CLASS (self)->finalize (self);
#line 20 "../src/Utils/TimeUtils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1206 "TimeUtils.c"
	}
}

